/*
 * @(#)AppDeamon.java	1.00 3/3/01
 * Copyright (c) 2001 by Paul Regenhardt,  All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Paul Regenhardt ("Confidential Information"). You shall not 
 * disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Paul Regenhardt.
 */

import java.util.*;
import java.io.*;
import java.net.*;

/**
 * This class inherits from a Telnet Client/Server class to server
 * as an example of a client/server interface using Telnet with Java.
 * it understands these commands:
 * date
 * act-user
 * canc-user
 * 
 * @author Paul Regenhardt
 * @version 1.0
 */


public class AppDeamon extends TelnetDeamon
{
	static public void main(String args[])
	{
	    TelnetDeamon.start(args);
	    new AppDeamon();
	}
	
	public AppDeamon()
	{
	    super();
	}
	
	// This is the main processing loop
    public void performAction(TelnetThread t, String s)
    {
        // perform an action
        String parameter=null;
        String action;
        int actionLength=s.indexOf(32);
        if (actionLength < 0) { // no arguments
            action = s.substring(0,s.length());
            parameter= new String(" ");
        } else {
            int l = s.length();
            action = s.substring(0,actionLength);
            if (l > actionLength+1) parameter = s.substring(actionLength+1, l);
        }
        
        // log user, action and parameters
        
        // Commands that can be executed without validation
        
        if (action.equals("?")) {
            t.transmit("\nI can respond to ?, act-user, date, and canc-user...\n");
            return;
        } else if ((action.toUpperCase()).equals("ACT-USER")) {
            t.authenticate(true); // validating user
            t.transmit("\nUser logged in!\n");
            return;
        } else if ((action.toUpperCase()).equals("CANC-USER")) {
            t.transmit("\nbye!\n");
            closeConnection(t);
            return;
        }
        
        // All Commands below this point require validation
        if (!t.isAuthenticated()) {
                t.transmit("\nUser not validated!  Command not processed!\n");
                return;
        }
        
        // Typical commands
        if ((action.toUpperCase()).equals("DATE")) {
                t.transmit("does anyone really know what day it is?\n");
        }
        
    }
}
